## mingw-w64-solid3-3.5.8-2.src.tar.zst

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.8)

project(SOLID)

set(CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/CMakeModules;${CMAKE_MODULE_PATH}")

include(GNUInstallDirs)

set(VERSION_MAJOR 3)
set(VERSION_MINOR 5)
set(VERSION_PATCH 8)
set(VERSION ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH})

set(CMAKE_DEBUG_POSTFIX  "_d")

set(OUTPUT_BINDIR ${PROJECT_BINARY_DIR}/bin)
make_directory(${OUTPUT_BINDIR})
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${OUTPUT_BINDIR})

set(OUTPUT_LIBDIR ${PROJECT_BINARY_DIR}/lib)
make_directory(${OUTPUT_LIBDIR})
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${OUTPUT_LIBDIR})
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${OUTPUT_LIBDIR})


# Dynamic vs Static Linking
option(DYNAMIC_SOLID "Set to ON to build SOLID for dynamic linking.  Use OFF for static." ON)

if(NOT DYNAMIC_SOLID)
  add_definitions(-DSOLID_STATIC)
endif(NOT DYNAMIC_SOLID)

option(USE_DOUBLES "Use double-precision floating-point numbers." OFF)

if(USE_DOUBLES)
  add_definitions(-DUSE_DOUBLES)
endif(USE_DOUBLES)

include_directories(
	${PROJECT_SOURCE_DIR}/include
)

if (WIN32)
  if (CMAKE_SIZEOF_VOID_P EQUAL 8)
	set(ARCH "x64")		
  else()
    set(ARCH "x86")	
  endif()	
  if (MSVC)
    if (MSVC90)
      set(PLATFORM "msvc90")
    elseif(MSVC10)
      set(PLATFORM "msvc100")
    elseif(MSVC11) 	
      set(PLATFORM "msvc110")
    elseif(MSVC12)
      set(PLATFORM "msvc120")
	elseif(MSVC14)
      set(PLATFORM "msvc140")
    else()
      set(PLATFORM "msvcxxx")
    endif()
  else()
    set(PLATFORM "unknown")
  endif ()

  set(GLUT_ROOT_PATH "${PROJECT_SOURCE_DIR}/../3rdPartyDeps/${ARCH}/${PLATFORM}")
endif(WIN32)


find_package(GLUT)
find_package(OpenGL)


if(MSVC) 
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /W3 /Oi /fp:fast /D_SCL_SECURE_NO_WARNINGS /D_CRT_SECURE_NO_WARNINGS")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /GR- /W3 /Oi /fp:fast /D_SCL_SECURE_NO_WARNINGS /D_CRT_SECURE_NO_WARNINGS")
  set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /GS-") 
  set(CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELWITHDEBINFO} /GS-") 
  set(CMAKE_EXE_LINKER_FLAGS_RELWITHDEBINFO "${CMAKE_EXE_LINKER_FLAGS_RELWITHDEBINFO} /INCREMENTAL:NO")
  set(CMAKE_SHARED_LINKER_FLAGS_RELWITHDEBINFO "${CMAKE_SHARED_LINKER_FLAGS_RELWITHDEBINFO} /INCREMENTAL:NO")
  if(CMAKE_CL_64)
  else(CMAKE_CL_64)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /arch:SSE2")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /arch:SSE2")
  endif(CMAKE_CL_64)
endif(MSVC)

if(UNIX)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -ffast-math -msse2 -mfpmath=sse")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-rtti -Wall -ffast-math -msse2 -mfpmath=sse")
  if (DYNAMIC_SOLID)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fPIC")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIC")
  endif(DYNAMIC_SOLID)
  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -lrt")
endif(UNIX)

add_subdirectory(src)
add_subdirectory(examples)
#add_subdirectory(doc)

include(CMakePackageConfigHelpers)

configure_package_config_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/solid3-config.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/solid3-config.cmake
  INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/solid3
)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/solid3-config.cmake DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/solid3 COMPONENT development)
write_basic_package_version_file(${CMAKE_CURRENT_BINARY_DIR}/solid3-config-version.cmake VERSION ${VERSION} COMPATIBILITY ExactVersion)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/solid3-config-version.cmake DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/solid3 COMPONENT development)
install(EXPORT solid3 DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/solid3 NAMESPACE solid3:: FILE solid3-export.cmake COMPONENT development)

set(CPACK_COMPONENT_DEVELOPMENT_DEPENDS runtime)
set(CPACK_DEB_COMPONENT_INSTALL ON)
set(CPACK_DEBIAN_DEVELOPMENT_FILE_NAME "DEB-DEFAULT")
set(CPACK_DEBIAN_DEVELOPMENT_PACKAGE_DEPENDS "libsolid3d")
set(CPACK_DEBIAN_DEVELOPMENT_PACKAGE_NAME "libsolid3d-dev")
set(CPACK_DEBIAN_DEVELOPMENT_PACKAGE_SECTION "libdevel")
set(CPACK_DEBIAN_PACKAGE_HOMEPAGE "http://www.dtecta.com/")
set(CPACK_DEBIAN_PACKAGE_NAME "libsolid3d")
set(CPACK_DEBIAN_PACKAGE_SECTION "devel")
set(CPACK_DEBIAN_RUNTIME_FILE_NAME "DEB-DEFAULT")
set(CPACK_DEBIAN_RUNTIME_PACKAGE_NAME "libsolid3d")
set(CPACK_DEBIAN_RUNTIME_PACKAGE_SECTION "libs")
set(CPACK_NSIS_PACKAGE_NAME "SOLID ${VERSION}")
set(CPACK_NSIS_URL_INFO_ABOUT ${CPACK_DEBIAN_PACKAGE_HOMEPAGE})
set(CPACK_PACKAGE_CONTACT "bugs@dtecta.com")
set(CPACK_PACKAGE_DISPLAY_NAME "SOLID ${VERSION}")
set(CPACK_PACKAGE_INSTALL_DIRECTORY "SOLID-${VERSION}")
set(CPACK_PACKAGE_NAME "SOLID")
set(CPACK_PACKAGE_VERSION ${VERSION})
set(CPACK_PACKAGE_VERSION_MAJOR ${VERSION_MAJOR})
set(CPACK_PACKAGE_VERSION_MINOR ${VERSION_MINOR})
set(CPACK_PACKAGE_VERSION_PATCH ${VERSION_PATCH})
set(CPACK_RESOURCE_FILE_LICENSE ${CMAKE_CURRENT_SOURCE_DIR}/LICENSE_GPL.txt)
set(CPACK_RPM_COMPONENT_INSTALL ON)
set(CPACK_RPM_DEVELOPMENT_FILE_NAME "RPM-DEFAULT")
set(CPACK_RPM_development_PACKAGE_NAME "SOLID-devel")
set(CPACK_RPM_development_PACKAGE_REQUIRES "SOLID")
set(CPACK_RPM_PACKAGE_GROUP "Development/Libraries")
set(CPACK_RPM_PACKAGE_LICENSE "GPL/QPL")
set(CPACK_RPM_PACKAGE_NAME "SOLID")
set(CPACK_RPM_PACKAGE_URL ${CPACK_DEBIAN_PACKAGE_HOMEPAGE})
set(CPACK_RPM_RUNTIME_FILE_NAME "RPM-DEFAULT")
set(CPACK_RPM_runtime_PACKAGE_NAME "SOLID")

if(WIN32 AND CMAKE_SIZEOF_VOID_P EQUAL 8)
	set(CPACK_NSIS_INSTALL_ROOT "$PROGRAMFILES64")
endif()

include(CPack)

=== examples/CMakeLists.txt ===
add_subdirectory(dynamics)

add_executable(sample sample.cpp)
add_dependencies(sample solid3)
set_target_properties(sample PROPERTIES DEBUG_POSTFIX _d)
target_link_libraries(sample solid3)

set(DEPS dynamics solid3)

if(GLUT_FOUND)

include_directories(
  ${PROJECT_SOURCE_DIR}/examples/dynamics
  ${GLUT_INCLUDE_DIR} 
  ${OPENGL_INCLUDE_DIR}
)

foreach(EXE gldemo mnm physics)
add_executable(${EXE} ${EXE}.cpp)
add_dependencies(${EXE} ${DEPS})
set_target_properties(${EXE} PROPERTIES DEBUG_POSTFIX _d)
target_link_libraries(${EXE} 
  ${DEPS}
  ${GLUT_LIBRARIES}
  ${OPENGL_LIBRARIES}
)
endforeach(EXE)

endif(GLUT_FOUND)

=== src/CMakeLists.txt ===
add_subdirectory(qhull)

if(DYNAMIC_SOLID)
  set(LIBRARY_TYPE "SHARED")
  add_definitions(-DSOLID_DLL_EXPORT)
else(DYNAMIC_SOLID)
  set(LIBRARY_TYPE "STATIC")
  add_definitions(-DSOLID_STATIC)
endif(DYNAMIC_SOLID)

include_directories(${PROJECT_SOURCE_DIR}/src)
include_directories(${PROJECT_SOURCE_DIR}/src/broad)
include_directories(${PROJECT_SOURCE_DIR}/src/convex)
include_directories(${PROJECT_SOURCE_DIR}/src/complex)

set(SOLID_PUBLIC_HEADERS 
  ${PROJECT_SOURCE_DIR}/include/SOLID.h
  ${PROJECT_SOURCE_DIR}/include/SOLID_broad.h
  ${PROJECT_SOURCE_DIR}/include/SOLID_types.h
)

add_library(solid3 ${LIBRARY_TYPE}
  ${SOLID_PUBLIC_HEADERS}
  broad/BP_C-api.cpp
  broad/BP_Endpoint.h
  broad/BP_EndpointList.cpp
  broad/BP_EndpointList.h
  broad/BP_Proxy.cpp
  broad/BP_Proxy.h
  broad/BP_ProxyList.h
  broad/BP_Scene.cpp
  broad/BP_Scene.h
  convex/DT_Accuracy.cpp
  convex/DT_Accuracy.h
  convex/DT_Array.h
  convex/DT_Box.cpp
  convex/DT_Box.h
  convex/DT_Cone.cpp
  convex/DT_Cone.h
  convex/DT_Convex.cpp
  convex/DT_Convex.h
  convex/DT_Cylinder.cpp
  convex/DT_Cylinder.h
  convex/DT_GJK.h
  convex/DT_Hull.h
  convex/DT_IndexArray.h
  convex/DT_LineSegment.cpp
  convex/DT_LineSegment.h
  convex/DT_Minkowski.h
  convex/DT_PenDepth.cpp
  convex/DT_PenDepth.h
  convex/DT_Point.cpp
  convex/DT_Point.h
  convex/DT_Polyhedron.cpp
  convex/DT_Polyhedron.h
  convex/DT_Polytope.cpp
  convex/DT_Polytope.h
  convex/DT_Shape.h
  convex/DT_Sphere.cpp
  convex/DT_Sphere.h
  convex/DT_Transform.h
  convex/DT_Triangle.cpp
  convex/DT_Triangle.h
  convex/DT_TriEdge.cpp
  convex/DT_TriEdge.h
  convex/DT_VertexBase.h
  complex/DT_BBoxTree.cpp
  complex/DT_BBoxTree.h
  complex/DT_CBox.h
  complex/DT_Complex.cpp
  complex/DT_Complex.h
  DT_AlgoTable.h
  DT_C-api.cpp
  DT_Encounter.cpp
  DT_Encounter.h
  DT_Object.cpp
  DT_Object.h
  DT_Response.h
  DT_RespTable.cpp
  DT_RespTable.h
  DT_Scene.cpp
  DT_Scene.h
  $<TARGET_OBJECTS:qhull>
)

target_include_directories(solid3 INTERFACE $<INSTALL_INTERFACE:$<INSTALL_PREFIX>/${CMAKE_INSTALL_INCLUDEDIR}>)
set_target_properties(solid3 PROPERTIES VERSION ${VERSION})

install(
    TARGETS solid3
    EXPORT solid3
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT development
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT runtime NAMELINK_SKIP
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR} COMPONENT runtime
)
if(DYNAMIC_SOLID)
    install(
        TARGETS solid3
        EXPORT solid3
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT development NAMELINK_ONLY
    )
endif()
install(
    FILES ${SOLID_PUBLIC_HEADERS}
    DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/SOLID
    COMPONENT development
)

if(MSVC AND DYNAMIC_SOLID AND ${CMAKE_MAJOR_VERSION} GREATER 2 AND ${CMAKE_MINOR_VERSION} GREATER 0)
    install(FILES $<TARGET_PDB_FILE:solid3> DESTINATION ${CMAKE_INSTALL_BINDIR} CONFIGURATIONS Debug RelWithDebInfo COMPONENT debug)
endif()

=== examples/dynamics/CMakeLists.txt ===
add_library(dynamics
  Dynamic.cpp
  Dynamic.h
  Kinetic.cpp
  Kinetic.h
  RigidBody.cpp
  RigidBody.h
)

=== src/qhull/CMakeLists.txt ===
add_library(qhull OBJECT
	geom.c
	geom.h
	geom2.c
	global.c
	io.c
	io.h
	mem.c
	mem.h
	merge.c
	merge.h
	poly.c
	poly.h
	poly2.c
	qhull.c
	qhull.h
	qhull_a.h
	qset.c
	qset.h
	stat.c
	stat.h
	user.c
	user.h
)

=== PKGBUILD ===
# Maintainer: Markus Rickert <rickert@fortiss.org>

_realname=solid3
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
_commit=c53f6bb1eaaafb1cfb305ef71b1c3a2edb4844e6
pkgver=3.5.8
pkgrel=2
pkgdesc="A software library for performing intersection tests and proximity queries (mingw-w64)"
arch=('any')
mingw_arch=('mingw32' 'mingw64' 'ucrt64' 'clang64' 'clangarm64' 'clang32')
url="https://github.com/dtecta/solid3"
license=('GPL' 'QPL')
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-qhull"
             "patch")
depends=("${MINGW_PACKAGE_PREFIX}-gcc-libs")
options=('strip' 'staticlibs')
source=("${_realname}-${pkgver}.tar.gz::https://github.com/dtecta/solid3/archive/${_commit}.tar.gz"
        "disable-examples.patch"
        "use-external-qhull.patch")
sha256sums=('fccb1fb30d8836d1c9216d3b36042b0a9651697fd743a4c4e9251dfea59ac964'
            '2c663db880d38c862c0b33eae9a44be3918547cff35196d0077365b5aa376a2b'
            '6dce2fea19456640a81a935b0405ae9b2d5d1167816578b86dd8299abbb47241')

prepare() {
  cd "${srcdir}"/${_realname}-${_commit}

  patch -Np1 -i "${srcdir}"/disable-examples.patch
  patch -Np1 -i "${srcdir}"/use-external-qhull.patch
}

build() {
  cd "${srcdir}"/${_realname}-${_commit}
  [[ -d "${srcdir}"/build-${CARCH} ]] && rm -rf "${srcdir}"/build-${CARCH}
  mkdir -p "${srcdir}"/build-${CARCH} && cd "${srcdir}"/build-${CARCH}

  declare -a extra_config
  if check_option "debug" "n"; then
    extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  ${MINGW_PREFIX}/bin/cmake \
    -GNinja \
    -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
    "${extra_config[@]}" \
    -DDYNAMIC_SOLID=ON \
    -DUSE_DOUBLES=ON \
    ../${_realname}-${_commit}

  ${MINGW_PREFIX}/bin/cmake --build .
}

package() {
  cd "${srcdir}"/build-${CARCH}

  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake --build . --target install

  install -Dm644 "${srcdir}/${_realname}-${_commit}/LICENSE_GPL.txt" "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE_GPL.txt"
  install -Dm644 "${srcdir}/${_realname}-${_commit}/LICENSE_QPL.txt" "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE_QPL.txt"
  install -Dm644 "${srcdir}/${_realname}-${_commit}/README.md" "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/README.md"
}
